// 1.Обьяснить своими словами разницу между обьявлением переменных через var, let и const.


/*
    
    1.1. Созданная через var переменная может быть вызвана в любой части кода.
        Т.е. является в глобальной. Если ее вызавть до объявления, то она получит значение "undefined".
        Ошибки в таком случае не будет.

    1.2. Const - переменная не ссылочного типа получает значение 1 раз и больше не может его изменить. Если ссылочного (объект),
        то ему можно добавлять\удалять\изменять свойства. При попытке повторного присвоения другого объекта или любого 
        другого типа данных переменной появится ошибка. При попытке вызова до объявления выдаст ошибку, как и при попытке поторного
        объявления в том же блоке.

    1.3. Let - это упрощенная замена var. Вызов переменной до объявления выдаст ошибку. Повторное объявление в том же блоке
        выдаст ошибку.
        Переприсваивание значений разрешено. Ограничивается блоком (фукция или условия...)

    1.4. Все, что объявлено внутри фукнции (класса, наверно, тоже) остается внутри. При попытке вызова переменной let, const
        вне функции выдаст ошибку. Var 

*/
 
let a = 33
var b = 44
console.log('var',c); //undefined
if(1 > 0)
{
    let a = 2
    var b = 100
    var c = 120
    console.log(a,b,c); // 2, 100, 120
}
// var b = 100
console.log(a,b,c); // 33, 100, 120

// 2. Почему объявлять переменную через var считается плохим тоном?

/*
    2.1. При написании сложных приложений можно случайно присвоить разные значения одной и той же переменной.
    2.2. Безопасность. Я бы переменной с важной инфой не рискнул бы давать глобальность.
    2.3. В циклах переменную лучше объявлять в инициализации. Var по окончании переменную НЕ удалит 
        и передаст ее последнее значение за пределы цикла. Использовать такую переменную в след. цикле я бы не
        рискнул.
*/

// let i = 0, j = 0
// var j = 0 ,i
console.log('j', j)
for( var i = 0,j = 2; i < 10; i++, j++)
{
    console.log('var i', i, j)
}
console.log('i', i)
console.log('j', j)